#if defined(SPARKFUN_HYPERDISPLAY)

#include <Arduino.h>
#include <HyperDisplay_4DLCD-320240_4WSPI.h>
#include "Display.h"


namespace Display {


static LCD320240_4WSPI		tft;
static ILI9341_color_18_t	defaultColor;
static uint16_t			line = 0;


void	
Init()
{
	tft.begin(D1, D0, PWM0, SPI, 32000000);
	tft.setInterfacePixelFormat(ILI9341_PXLFMT_18);
	tft.clearDisplay();

	defaultColor = tft.rgbTo18b(255, 255, 255); 
	tft.setCurrentWindowColorSequence((color_t)&defaultColor);
}


void
Clear()
{
	Clear(false);
}


void
Clear(bool hint)
{
	if (hint) {
		return;
	}
	tft.clearDisplay();
	SetCursor(0, 0);
	line = 0;
}


void
Draw()
{

}


bool
HasDisplay()
{
	return true;
}


void
Print(const char *s)
{
	tft.print(s);
	Serial.print(s);
}


void
Println(const char *s)
{
	tft.println(s);
	Serial.println(s);
	line++;
	SetCursor(0, line*10);
}


void
SetCursor(int16_t x, int16_t y)
{
	tft.setTextCursor(x, y);
}


} // namespace Display

#endif
